#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Script Start - Add your code below here

#include <Date.au3>
#Include <File.au3>
#Include <Array.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

;variable establishment
dim $aCollectFolder
Dim $aConfigFiles
$year = ""
$month = ""
$ConfigFile = ""
$CurrentBillFile = ""
$kWh = 0
$currentCustomer = ""
$WhipDesc = ""
$GoodReadings = 0

#Region ### START Koda GUI section ### Form=C:\Users\Greg\Desktop\autoit\modbus monitor\bcm interface\process.kxf
$Form1 = GUICreate("Process kWhs", 203, 110, 192, 124)
$Label1 = GUICtrlCreateLabel("Year", 24, 8, 26, 17)
$Label2 = GUICtrlCreateLabel("Month", 107, 8, 34, 17)
$cboYear = GUICtrlCreateCombo("", 8, 32, 57, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "2011|2012|2013|2014|2015|2016|2017|2018|2019|2020|2021")
$cboMonth = GUICtrlCreateCombo("", 85, 32, 81, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "1|2|3|4|5|6|7|8|9|10|11|12")
$btnProcess = GUICtrlCreateButton("Process", 8, 64, 65, 25)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

GUICtrlSetData($cboYear, @YEAR)
if @MON == 1 Then
	GUICtrlSetData($cboMonth, 12)
Else
	GUICtrlSetData($cboMonth, @MON - 1)
EndIf

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $btnProcess
			;process button clicked.
			ToolTip("processing start",0,0)
			$year = GUICtrlRead($cboYear)
			$month = GUICtrlRead($cboMonth)
			if StringLen($month) == 1 Then
				$month = "0" & $month
			EndIf
			DirCreate(@ScriptDir & "\bills")
			DirCreate(@ScriptDir & "\bills\" & $year)
			_ListFiles()
			_ProcessList()
			_TotalValues()
			ToolTip("processing complete",0,0)
		Case $GUI_EVENT_CLOSE
			Exit

	EndSwitch
WEnd

Func _ListFiles()
	;
	$aCollectFolder=_FileListToArray(@ScriptDir & "\" & $year,"*.csv")
	If @Error=1 Then
		MsgBox (0,"","No Folders Found.")
		Exit
	EndIf
	If @Error=4 Then
		MsgBox (0,"","No Files Found. _listfiles")
		Exit
	EndIf
	;_ArrayDisplay($aCollectFolder,"poop")

EndFunc

Func _ListConfigs()
	;

	$aConfigFiles =_FileListToArray(@ScriptDir & "\configs")
	If @Error=1 Then
		MsgBox (0,"","No Folders Found.")
		Exit
	EndIf
	If @Error=4 Then
		MsgBox (0,"","No Files Found. _listconfigs")
		Exit
	EndIf

EndFunc

Func _ProcessList()
	;

	$BillFileTotals =_FileListToArray(@ScriptDir & "\bills\" & $year)
	If @Error=1 Then
		MsgBox (0,"","No Folders Found.")
		Exit
	EndIf
	If @Error=4 Then
		MsgBox (0,"","No Files Found. _processlist" & @crlf & "don't have any files in the folder yet, no big deal.",2)
	Else
		for $x = 1 to $BillFileTotals[0]
			;
			if StringLeft($BillFileTotals[$x], StringLen($month)) == $month Then
				;delete it
				FileDelete(@ScriptDir & "\bills\" & $year & "\" & $BillFileTotals[$x])
			EndIf
		Next
	EndIf
	for $x = 1 to $aCollectFolder[0]
		;
		if StringLeft($aCollectFolder[$x],StringLen($month)) == $month Then
			;this is our month
			;delete existing bill files
			$ConfigFile = StringMid($aCollectFolder[$x], StringLen($month) + 2, StringLen($aCollectFolder[$x]) - 4 - StringLen($month) - 1) & ".txt"
			Dim $aProcessFile
			If Not _FileReadToArray(@ScriptDir & "\" & $year & "\" & $aCollectFolder[$x],$aProcessFile) Then
				MsgBox(4096,"Error", " Error reading log to Array  $aprocessfile   error:" & @error)
				Exit
			EndIf
			Dim $aConfigFileProcess
			If Not _FileReadToArray(@ScriptDir & "\configs\" & $ConfigFile,$aConfigFileProcess) Then
				MsgBox(4096,"Error", " Error reading log to Array    $aconfigfileprocess error:" & @error)
				Exit
			EndIf
			;start processing
			Dim $aTemp[43]
			for $y = 1 to 42
				;
				$aTemp[$y] = 0
			Next
			$GoodReadings = 0
			for $y = 1 to $aprocessfile[0]
				for $z = 1 to 42
					;ensure that you don't have a blank line
					if StringInStr($aprocessfile[$y],",",0,42) > 0 Then
						;increment our counter here only if it is the first variable in this loop
						if $z == 1 Then
							$GoodReadings = $GoodReadings + 1
						EndIf
						$aTemp[$z] = $aTemp[$z] + StringMid($aprocessfile[$y],StringInStr($aprocessfile[$y],",",0,$z) + 1, StringInStr($aprocessfile[$y],",",0,$z + 1) - StringInStr($aprocessfile[$y],",",0,$z) - 1)
					EndIf
				Next
			Next
					for $s = 1 to 42
						;special processing for values.  average the amperage from collected values.
						;then multiply it by the number of hours in the month.
						;get average number
						;MsgBox(0,$s, $aTemp[$s] & " / " & $GoodReadings & " = " & $aTemp[$s] / $GoodReadings)
						$aTemp[$s] = $aTemp[$s] / $GoodReadings
						;figure out what that would be for the month.
						;MsgBox(0,$s, $aTemp[$s] & " * " & _DateDaysInMonth($year,$month) & " * 24 = " & $aTemp[$s] * _DateDaysInMonth($year,$month) * 24)
						$aTemp[$s] = $aTemp[$s] * _DateDaysInMonth($year,$month) * 24
					Next

			for $y = 1 to 42
				$kWh = 0
				$WhipDesc = StringLeft($aConfigFileProcess[$y], StringInStr($aConfigFileProcess[$y],",") - 1)
				if $WhipDesc <> "Channel Description" Then
					$currentCustomer = StringLeft($aConfigFileProcess[$y],StringInStr($aConfigFileProcess[$y],"-") - 1)


					;we have one to process
					if StringMid($aConfigFileProcess[$y], StringInStr($aConfigFileProcess[$y],",") + 1, StringInStr($aConfigFileProcess[$y],",",0,2) - StringInStr($aConfigFileProcess[$y],",") - 1) == 120 Then
						;process 120
						if $aTemp[$y] <> 0 then
							;$kWh = $aTemp[$y] / 10 / 4 * 120 / 1000
							$kWh = $aTemp[$y] / 10 * 120 / 1000
						Else
							$kWh = 0
						EndIf
						_WriteLine()
					elseif StringMid($aConfigFileProcess[$y], StringInStr($aConfigFileProcess[$y],",") + 1, StringInStr($aConfigFileProcess[$y],",",0,2) - StringInStr($aConfigFileProcess[$y],",") - 1) == 208 Then
						;process 208
						if $aTemp[$y] <> 0 then
							;$kWh = ($aTemp[$y] + $aTemp[$y + 2]) / 10 / 2 / 4 * 208 / 1000
							$kWh = ($aTemp[$y] + $aTemp[$y + 2]) / 10 / 2 * 208 / 1000
						Else
							$kWh = 0
						EndIf
						_WriteLine()
					Else
						;this is a 208 3 phase
						if $aTemp[$y] <> 0 then
							;$kWh = ($aTemp[$y] + $aTemp[$y + 2] + $aTemp[$y + 4]) / 10 / 3 / 4 * 208 * 1.732 * .98 / 1000
							$kWh = ($aTemp[$y] + $aTemp[$y + 2] + $aTemp[$y + 4]) / 10 / 3 * 208 * 1.732 / 1000
							;MsgBox(0,$y,$aTemp[$y] & " + " & $aTemp[$y + 2] & " + " & $aTemp[$y + 4] & " / 10 / 3 * 208 * 1.732 / 1000" & " = " & $kWh)
						Else
							$kWh = 0
						EndIf
						_WriteLine()
					EndIf
				EndIf
			Next

		EndIf
	Next
EndFunc

Func _WriteLine()
	;
	$WriteFile = FileOpen(@ScriptDir & "\bills\" & $year & "\" & $month & "-" & $currentCustomer & ".csv" , 1)

	; Check if file opened for writing OK
	If $WriteFile = -1 Then
		MsgBox(0, "Error", "Unable to open file.")
		Exit
	EndIf
	FileWriteLine($WriteFile, $WhipDesc & "," & $kWh & @CRLF)

	FileClose($WriteFile)

EndFunc

Func _TotalValues()
	;
	$BillFileTotals =_FileListToArray(@ScriptDir & "\bills\" & $year)
	If @Error=1 Then
		MsgBox (0,"","No Folders Found.")
		Exit
	EndIf
	If @Error=4 Then
		MsgBox (0,"","No Files Found. _totalvalues")
		Exit
	EndIf
	for $x = 1 to $BillFileTotals[0]
		;
		$tTotalkWh = 0
		if StringLeft($BillFileTotals[$x], StringLen($month)) == $month Then
			;we've found one of our bill files
			Dim $aBillFileTotal
			If Not _FileReadToArray(@ScriptDir & "\bills\" & $year & "\" & $BillFileTotals[$x],$aBillFileTotal) Then
				MsgBox(4096,"Error", " Error reading log to Array     error:" & @error)
				Exit
			EndIf
			For $y = 1 to $aBillFileTotal[0]
				$tTotalkWh = $tTotalkWh + StringMid($aBillFileTotal[$y],StringInStr($aBillFileTotal[$y],",") + 1)
			Next
			;write the kWh total back to file
			$WriteTotalFile = FileOpen(@ScriptDir & "\bills\" & $year & "\" & $BillFileTotals[$x], 1)

			; Check if file opened for writing OK
			If $WriteTotalFile = -1 Then
				MsgBox(0, "Error", "Unable to open file.")
				Exit
			EndIf

			FileWriteLine($WriteTotalFile, "Total," & $tTotalkWh & @CRLF)

			FileClose($WriteTotalFile)

		EndIf
	Next
EndFunc